#ifndef	_H_BUILDIO_
#define	_H_BUILDIO_

/** \ingroup rpmbuild
 * \file build/buildio.h
 * Routines to read and write packages.
 * @deprecated this information will move elsewhere eventually.
 * @todo Eliminate, merge into rpmlib.
 */

#include "rpmbuild.h"

/**
 */
typedef struct cpioSourceArchive_s * CSA_t;
struct cpioSourceArchive_s {
    rpmuint32_t	cpioArchiveSize;
    FD_t	cpioFdIn;
    rpmfi	fi;
    struct rpmlead * lead;	/* XXX FIXME: exorcize lead/arch/os */
};

#ifdef __cplusplus
extern "C" {
#endif

#if defined(DEAD)
/**
 * Read rpm package components from file.
 * @param fileName	file name of package (or NULL to use stdin)
 * @retval specp	spec structure to carry package header (or NULL)
 * @retval lead		package lead
 * @retval sigs		package signature
 * @param csa		csa
 * @return		0 on success
 */
int readRPM(const char * fileName, Spec * specp, void * l,
		Header * sigs, CSA_t csa);
#endif

/**
 * Write rpm package to file.
 *
 * @warning The first argument (header) is now passed by reference in order to
 * return a reloaded contiguous header to the caller.
 *
 * @retval *hdrp	header to write (final header is returned).
 * @retval *pkgidp	header+payload MD5 of package (NULL to disable).
 * @param fileName	file name of package
 * @param csa		csa
 * @param passPhrase	passPhrase
 * @retval cookie	generated cookie (i.e build host/time)
 * @param _dig		DSA keypair for auto-signing (or NULL)
 * @return		RPMRC_OK on success
 */
rpmRC writeRPM(Header * hdrp, unsigned char ** pkgidp,
		const char * fileName,
		CSA_t csa,
		char * passPhrase,
		const char ** cookie, void * _dig);

#ifdef __cplusplus
}
#endif

#endif	/* _H_BUILDIO_ */
