#!/bin/sh

#run this with a mozilla-release directory with the untarred firefox download

rm -rf extract

mkdir -p extract/
mkdir -p extract/js/
mkdir -p extract/memory/build/
mkdir -p extract/memory/fallible/
mkdir -p extract/memory/mozjemalloc/
mkdir -p extract/memory/mozalloc/
mkdir -p extract/mozglue/misc/
mkdir -p extract/intl/icu/source/common/unicode/

cp -p -r mozilla-release/js/src mozilla-release/js/public extract/js/
cp -p -r mozilla-release/mfbt extract/

# We need these even without ICU
cp -p mozilla-release/intl/icu/source/common/unicode/platform.h extract/intl/icu/source/common/unicode
cp -p mozilla-release/intl/icu/source/common/unicode/ptypes.h extract/intl/icu/source/common/unicode
cp -p mozilla-release/intl/icu/source/common/unicode/uconfig.h extract/intl/icu/source/common/unicode
cp -p mozilla-release/intl/icu/source/common/unicode/umachine.h extract/intl/icu/source/common/unicode
cp -p mozilla-release/intl/icu/source/common/unicode/urename.h extract/intl/icu/source/common/unicode
cp -p mozilla-release/intl/icu/source/common/unicode/utypes.h extract/intl/icu/source/common/unicode
cp -p mozilla-release/intl/icu/source/common/unicode/uvernum.h extract/intl/icu/source/common/unicode
cp -p mozilla-release/intl/icu/source/common/unicode/uversion.h extract/intl/icu/source/common/unicode

cp -p -r mozilla-release/memory/build/moz*.h extract/memory/build
cp -p -r mozilla-release/memory/fallible/fallible.h extract/memory/fallible
cp -p -r mozilla-release/memory/mozjemalloc/jemalloc_types.h extract/memory/mozjemalloc
cp -p -r mozilla-release/memory/mozalloc/mozalloc_abort.h extract/memory/mozalloc
cp -p -r mozilla-release/memory/mozalloc/mozalloc.h extract/memory/mozalloc
cp -p -r mozilla-release/memory/mozalloc/mozalloc_oom.h extract/memory/mozalloc
cp -p -r mozilla-release/mozglue/misc/StackWalk.h extract/mozglue/misc
cp -p -r mozilla-release/mozglue/misc/TimeStamp.h extract/mozglue/misc

cd mozilla-release/js/src

# only need js/src, js/public and mfbt.  Well, we also need 8 of the icu
# headers, but only to stub out functions that fail at runtime
#PYTHON=python ./configure --without-intl-api --enable-posix-nspr-emulation
PYTHON=python ./configure \
	--host=x86_64-redhat-linux-gnu --target=x86_64-redhat-linux-gnu \
	--program-prefix= \
	--disable-dependency-tracking \
	--prefix=/usr \
	--exec-prefix=/usr \
	--bindir=/usr/bin \
	--sbindir=/usr/sbin \
	--sysconfdir=/etc \
	--datadir=/usr/share \
	--includedir=/usr/include \
	--libdir=/usr/lib64 \
	--libexecdir=/usr/libexec \
	--localstatedir=/var \
	--sharedstatedir=/var/lib \
	--mandir=/usr/share/man \
	--infodir=/usr/share/info \
	--enable-release \
	--enable-optimize \
	--enable-pie \
	--enable-readline \
	--enable-shared-js \
	--enable-system-ffi \
	--enable-xterm-updates \
	--with-pthreads \
	--with-system-nspr \
	--with-system-icu \
	--with-system-zlib \
	--with-intl-api \
	--enable-ctypes

#	--enable-more-deterministic
#	--enable-jitspew
#	--enable-gczeal
#	--enable-gc-trace

echo "CPPSRCS += \$(DEPTH)/mfbt/Unified_cpp_mfbt0.cpp \$(DEPTH)/../../mfbt/Compression.cpp \$(DEPTH)/../../mfbt/decimal/Decimal.cpp" >> js/src/backend.mk
#echo "STATIC_LIBS += \$(DEPTH)/mfbt/libmfbt.a" >> js/src/backend.mk

# skipping icu and relying on posix nspr emulation all helps.  After that we
# we have to run make to generate a byte code version of the self hosted js and
# a switch table
make -j8
#make |& sed -e 's,/home/X/src/wdj54/js/mozilla-release,,g' | sed -e 's,/X/src/wdj54/js/mozilla-release,,g' | tee xxx

cd ../../..

cp -p mozilla-release/js/src/js/src/selfhosted.out.h extract/js/src
cp -p mozilla-release/js/src/js/src/jsautokw.h extract/js/src
cp -p mozilla-release/js/src/js/src/shell/shellmoduleloader.out.h extract/js/src/shell

# mfbt doesn't change by arch or platform, so keep the same unified cpp
mkdir -p extract/js/src/mfbt/
cp -p mozilla-release/js/src/mfbt/Unified_cpp_mfbt0.cpp extract/js/src/mfbt

sed 's/#include ".*\/mfbt\//#include "/' < extract/js/src/mfbt/Unified_cpp_mfbt0.cpp > t1
sed 's/#error ".*\/mfbt\//#error "/' < t1 > extract/js/src/mfbt/Unified_cpp_mfbt0.cpp
rm t1

# stuff we can toss
rm -rf \
    extract/js/src/all-tests.json \
    extract/js/src/backend.mk \
    extract/js/src/backend.RecursiveMakeBackend \
    extract/js/src/backend.RecursiveMakeBackend.pp \
    extract/js/src/_build_manifests \
    extract/js/src/config \
    extract/js/src/config.cache \
    extract/js/src/config.log \
    extract/js/src/config.status \
    extract/js/src/configure \
    extract/js/src/configure.in \
    extract/js/src/doc \
    extract/js/src/editline \
    extract/js/src/gdb \
    extract/js/src/ipc \
    extract/js/src/jit-test \
    extract/js/src/jsapi-tests \
    extract/js/src/Makefile \
    extract/js/src/Makefile.in \
    extract/js/src/make-source-package.sh \
    extract/js/src/octane \
    extract/js/src/python \
    extract/js/src/README.html \
    extract/js/src/root-deps.mk \
    extract/js/src/root.mk \
    extract/js/src/skip_subconfigures \
    extract/js/src/subconfigures \
    extract/js/src/tests \
    extract/js/src/_virtualenv

# stuff we have to replace
rm -rf \
    extract/js/src/vm/PosixNSPR.cpp \
    extract/js/src/vm/PosixNSPR.h \

# stuff we don't want to deal with due to licensing
rm -rf \
    extract/mfbt/tests \
    extract/js/src/vm/make_unicode.py \
    extract/js/src/vtune

# this is all of the EXPORTS files from the moz.build's
mkdir -p include/
cp -p mozilla-release/js/src/js/src/js-config.h include

FILES="
    js.msg
    jsalloc.h
    jsapi.h
    jsbytecode.h
    jsclist.h
    jscpucfg.h
    jsfriendapi.h
    jsprf.h
    jsprototypes.h
    jspubtd.h
    jstypes.h
    jsversion.h
    jswrapper.h
    perf/jsperf.h
    selfhosted.out.h
    jsautokw.h
    shell/shellmoduleloader.out.h
"
for F in $FILES; do
    cp -p extract/js/src/$F include
done

# this is all of the EXPORTS.js files from the moz.build's
mkdir -p include/js/
FILES="
    CallArgs.h
    CallNonGenericMethod.h
    CharacterEncoding.h
    Class.h
    Conversions.h
    Date.h
    Debug.h
    GCAPI.h
    GCHashTable.h
    HashTable.h
    HeapAPI.h
    Id.h
    Initialization.h
    LegacyIntTypes.h
    MemoryMetrics.h
    Principals.h
    ProfilingFrameIterator.h
    ProfilingStack.h
    Proxy.h
    RequiredDefines.h
    RootingAPI.h
    SliceBudget.h
    StructuredClone.h
    TraceKind.h
    TraceableVector.h
    TracingAPI.h
    TrackedOptimizationInfo.h
    TypeDecls.h
    UbiNode.h
    UbiNodeBreadthFirst.h
    UbiNodeCensus.h
    UbiNodeDominatorTree.h
    UbiNodePostOrder.h
    Utility.h
    Value.h
    Vector.h
    WeakMapPtr.h
"
for F in $FILES; do
    [ -f extract/js/public/$F ] && cp -p extract/js/public/$F include/js
done

# Fedorable mozjs-XY distributes these files
FILES="
    memory/build/mozmemory.h
    memory/build/mozmemory_wrap.h
    memory/mozjemalloc/jemalloc_types.h
"
for F in $FILES; do
    [ -f extract/$F ] && cp -p extract/$F include
done

mkdir -p include/mozilla
FILES="
    memory/fallible/fallible.h
    memory/mozalloc/mozalloc_abort.h
    memory/mozalloc/mozalloc.h
    memory/mozalloc/mozalloc_oom.h
    mozglue/misc/StackWalk.h
    mozglue/misc/TimeStamp.h
"
for F in $FILES; do
    [ -f extract/$F ] && cp -p extract/$F include/mozilla
done

# this is all of the EXPORTS.mozilla files from the moz.build's
mkdir -p include/mozilla
FILES="
    Alignment.h
    AllocPolicy.h
    AlreadyAddRefed.h
    Array.h
    ArrayUtils.h
    Assertions.h
    Atomics.h
    Attributes.h
    BinarySearch.h
    BloomFilter.h
    Casting.h
    ChaosMode.h
    Char16.h
    CheckedInt.h
    Compiler.h
    Compression.h
    DebugOnly.h
    Decimal.h
    double-conversion/double-conversion.h
    double-conversion/utils.h
    Endian.h
    EnumeratedArray.h
    EnumeratedRange.h
    EnumSet.h
    fallible.h
    FastBernoulliTrial.h
    FloatingPoint.h
    Function.h
    GuardObjects.h
    HashFunctions.h
    IndexSequence.h
    IntegerPrintfMacros.h
    IntegerRange.h
    IntegerTypeTraits.h
    JSONWriter.h
    Likely.h
    LinkedList.h
    LinuxSignal.h
    MacroArgs.h
    MacroForEach.h
    MathAlgorithms.h
    Maybe.h
    MaybeOneOf.h
    MemoryChecking.h
    MemoryReporting.h
    Move.h
    mozalloc_abort.h
    mozalloc.h
    mozalloc_oom.h
    NullPtr.h
    NumericLimits.h
    Opaque.h
    Pair.h
    PodOperations.h
    Poison.h
    Range.h
    RangedArray.h
    RangedPtr.h
    RefCounted.h
    RefCountType.h
    ReentrancyGuard.h
    RefPtr.h
    ReverseIterator.h
    RollingMean.h
    Scoped.h
    ScopeExit.h
    SegmentedVector.h
    SHA1.h
    SizePrintfMacros.h
    Snprintf.h
    SplayTree.h
    StackWalk.h
    TaggedAnonymousMemory.h
    TemplateLib.h
    ThreadLocal.h
    TimeStamp.h
    ToString.h
    Tuple.h
    TypedEnumBits.h
    Types.h
    TypeTraits.h
    UniquePtr.h
    UniquePtrExtensions.h
    unused.h
    Variant.h
    Vector.h
    WeakPtr.h
    WindowsVersion.h
    XorShift128PlusRNG.h
    decimal/Decimal.h
"
for F in $FILES; do
    [ -f extract/mfbt/$F ] && cp -p extract/mfbt/$F include/mozilla
done

# Apply a local patch (best effort)
if [ -d mongo_patches ]; then
  git apply -p4 \
    mongo_patches/SERVER-23358.patch \
    mongo_patches/SERVER-24400.patch \
    mongo_patches/SERVER-22927-x86_64.patch \
    || :
fi
