#!/bin/sh

if [ $# -ne 2 ]
then
    echo "Please supply an arch: x86_64, i386, etc and a platform: osx, linux, windows, etc"
    exit 0;
fi

# the two files we need are js-confdefs.h which get used for the build and
# js-config.h for library consumers.  We also get different unity source files
# based on configuration, so save those too.

cd mozilla-release/js/src

#PYTHON=python ./configure --without-intl-api --enable-posix-nspr-emulation --disable-trace-logging
PYTHON=python ./configure \
	--host=x86_64-redhat-linux-gnu --target=x86_64-redhat-linux-gnu \
	--program-prefix= \
	--disable-dependency-tracking \
	--prefix=/usr \
	--exec-prefix=/usr \
	--bindir=/usr/bin \
	--sbindir=/usr/sbin \
	--sysconfdir=/etc \
	--datadir=/usr/share \
	--includedir=/usr/include \
	--libdir=/usr/lib64 \
	--libexecdir=/usr/libexec \
	--localstatedir=/var \
	--sharedstatedir=/var/lib \
	--mandir=/usr/share/man \
	--infodir=/usr/share/info \
	--enable-release \
	--enable-optimize \
	--enable-pie \
	--enable-readline \
	--enable-shared-js \
	--enable-system-ffi \
	--enable-xterm-updates \
	--with-pthreads \
	--with-system-nspr \
	--with-system-icu \
	--with-system-zlib \
	--with-intl-api \
	--enable-ctypes

#	--enable-more-deterministic
#	--enable-jitspew
#	--enable-gczeal
#	--enable-gc-trace

cd ../../..

#destdir="platform/$1/$2"
#srcdir=build
destdir=.
srcdir=src

mkdir -p "$destdir/include"
cp -p mozilla-release/js/src/js/src/js-config.h "$destdir/include"

subdir="$destdir/$srcdir"
mkdir -p "$subdir/.deps/"
mkdir -p "$subdir/.old/"
mv -f $subdir/Unified*.cpp "$subdir/.old/" 2>/dev/null

cp -p mozilla-release/js/src/js/src/js-confdefs.h "$subdir"
cp -p mozilla-release/js/src/js/src/Unified_*.cpp "$subdir"

for subfile in $subdir/*.cpp ; do
	sed 's/#include ".*\/js\/src\//#include "/' < "$subfile" > t1
	sed 's/#error ".*\/js\/src\//#error "/' < t1 > "$subfile"
	rm t1
	file=$(basename "$subfile")
	depfile=$(basename "$file" .cpp).Po
	reffile="$subdir/.old/$file"
	if [ -f "$reffile" ]; then
	    touch -r "$reffile" "$subfile"
	    touch -r "$reffile" "$subdir/.deps/rpmjs45-$depfile"
	    touch -r "$reffile" "$subdir/.deps/$depfile"
	else
	    touch "$subdir/.deps/rpmjs45-$depfile"
	    touch "$subdir/.deps/$depfile"
	fi
done
rm -rf "$subdir/.old/"

subdir="$destdir/$srcdir/shell"
mkdir -p "$subdir/.deps/"
mkdir -p "$subdir/.old/"
mv -f $subdir/Unified*.cpp "$subdir/.old/" 2>/dev/null

cp -p mozilla-release/js/src/js/src/shell/Unified_* "$subdir"

for subfile in $subdir/*.cpp ; do
	sed 's/#include ".*\/js\/src\//#include "/' < "$subfile" > t1
	sed 's/#error ".*\/js\/src\//#error "/' < t1 > "$subfile"
	rm t1
	file=$(basename "$subfile")
	depfile=$(basename "$file" .cpp).Po
	reffile="$subdir/.old/$file"
	if [ -f "$reffile" ]; then
	    touch -r "$reffile" "$subfile"
	    touch -r "$reffile" "$subdir/.deps/rpmjs45-$depfile"
	    touch -r "$reffile" "$subdir/.deps/$depfile"
	else
	    touch "$subdir/.deps/rpmjs45-$depfile"
	    touch "$subdir/.deps/$depfile"
	fi
done
rm -rf "$subdir/.old/"
