/** \ingroup rpmio
 * \file rpmdb/rpmmdb.c
 */

#include "system.h"

#include <rpmiotypes.h>
#include <rpmio.h>	/* for *Pool methods */
#include <rpmlog.h>
#include <rpmurl.h>

#define	_RPMMDB_INTERNAL
#include <rpmmdb.h>

#include "debug.h"

rpmmdb _rpmmdbI;

/*==============================================================*/

static void rpmmdbFini(void * _mdb)
{
    rpmmdb mdb = (rpmmdb) _mdb;

    mdb->fn = _free(mdb->fn);
}

int _rpmmdb_debug = 0;

#define	rpmmdbDbug	NULL
#define	rpmmdbInit	NULL
RPMIOPOOL_MODULE(mdb)

rpmmdb rpmmdbNew(const char * fn, int flags)
{
    rpmmdb mdb = rpmmdbGetPool(_rpmmdbPool);

    if (fn)
	mdb->fn = xstrdup(fn);

    return rpmmdbLink(mdb);
}
