#ifndef	H_RPMMDB
#define	H_RPMMDB

/** \ingroup rpmio
 * \file rpmdb/rpmmdb.h
 */

/** \ingroup rpmio
 */
typedef struct rpmmdb_s * rpmmdb;

/** \ingroup rpmdb
 */
extern int _rpmmdb_debug;

extern rpmmdb _rpmmdbI;

#if defined(_RPMMDB_INTERNAL)
/** \ingroup rpmdb
 */
struct rpmmdb_s {
    struct rpmioItem_s _item;	/*!< usage mutex and pool identifier. */
    const char * fn;
};
#endif	/* _RPMMDB_INTERNAL */

#ifdef __cplusplus
extern "C" {
#endif

/**
 * Unreference a mongodb wrapper instance.
 * @param mdb		mongodb wrapper
 * @return		NULL on last dereference
 */
rpmmdb rpmmdbUnlink (rpmmdb mdb);
#define	rpmmdbUnlink(_mdb)	\
    ((rpmmdb)rpmioUnlinkPoolItem((rpmioItem)(_mdb), __FUNCTION__, __FILE__, __LINE__))

/**
 * Reference a mongodb wrapper instance.
 * @param mdb		mongodb wrapper
 * @return		new mongodb wrapper reference
 */
rpmmdb rpmmdbLink (rpmmdb mdb);
#define	rpmmdbLink(_mdb)	\
    ((rpmmdb)rpmioLinkPoolItem((rpmioItem)(_mdb), __FUNCTION__, __FILE__, __LINE__))

/**
 * Destroy a mongodb wrapper.
 * @param mdb		mongodb wrapper
 * @return		NULL on last dereference
 */
rpmmdb rpmmdbFree(rpmmdb mdb);
#define	rpmmdbFree(_mdb)	\
    ((rpmmdb)rpmioFreePoolItem((rpmioItem)(_mdb), __FUNCTION__, __FILE__, __LINE__))

/**
 * Create and load a mongodb wrapper.
 * @param fn		mongodb file
 * @param flags		mongodb flags
 * @return		new mongodb wrapper
 */
rpmmdb rpmmdbNew(const char * fn, int flags);

#ifdef __cplusplus
}
#endif

#endif	/* H_RPMMDB */
