#ifndef H_RPMTXN
#define H_RPMTXN

/** \ingroup rpmdb
 * \file rpmdb/rpmtxn.h
 * Database transaction wrappers.
 */

extern int _rpmtxn_debug;

typedef void * rpmtxn;

#ifdef __cplusplus
extern "C" {
#endif

uint32_t rpmtxnId(rpmtxn txn);

const char * rpmtxnName(rpmtxn txn);

int rpmtxnSetName(rpmtxn txn, const char * N);

int rpmtxnAbort(rpmtxn txn);

int rpmtxnBegin(rpmdb rpmdb, rpmtxn parent, rpmtxn * txnp);

int rpmtxnCommit(rpmtxn txn);

int rpmtxnCheckpoint(rpmdb rpmdb);

#ifdef	NOTYET
int rpmtxnDiscard(rpmtxn txn);

int rpmtxnPrepare(rpmtxn txn);

int rpmtxnRecover(rpmdb rpmdb);
#endif	/* NOTYET */

#ifdef __cplusplus
}
#endif

#endif	/* H_RPMTXN */
