#ifndef H_ENVVAR
#define H_ENVVAR

/** \ingroup rpmio
 * \file rpmio/envvar.h
 */

#ifdef __cplusplus
extern "C" {
#endif

#if !defined(HAVE_CLEARENV)
static inline
int clearenv(void)
{
    environ = NULL;
    return 0;
}
#endif

static inline
const char * envGet(const char *name)
{
    const char * s = getenv(name);
    return s;
}

static inline
int envPut(const char *name, const char *value)
{
    char *t;
    char *te;
    size_t nb = 0;
    int rc;

    if (name && !*name)
	name = NULL;
    if (value && !*value)
	value = NULL;
    if (name == NULL && value == NULL) {
	rc = clearenv();
	return rc;
    }

    if (name)
	nb += strlen(name);
    if (value)
	nb += strlen(value) + 1;
    t = te = (char *) xmalloc(nb + 1);
    *te = '\0';
    if (name)
	te = stpcpy(te, name);
    if (value)
	te = stpcpy( stpcpy(te, "="), value);
    *te = '\0';

    rc = putenv(t);
    return rc;
}

#ifdef __cplusplus
}
#endif

#endif  /* H_ENVVAR */
