#ifndef	_H_RPMAIO_
#define	_H_RPMAIO_

/**
 */
extern int _rpmaio_debug;

typedef	struct rpmaio_s * rpmaio;

#if defined(_RPMAIO_INTERNAL)
enum {
    LIO_DSYNC	= LIO_NOP+1,
    LIO_SYNC,
    LIO_CLOSE,
    LIO_READ64	= LIO_READ | 128,
    LIO_WRITE64	= LIO_WRITE | 128,
};

struct rpmaio_s {
    struct rpmioItem_s _item;	/*!< usage mutex and pool identifier. */
    struct aiocb aiocb;
    int ix;
    char buf[BUFSIZ];
};
#endif

#ifdef __cplusplus
extern "C" {
#endif

/**
 * Unreference a aio wrapper instance.
 * @param aio		aio wrapper
 * @return		NULL on last dereference
 */
rpmaio rpmaioUnlink (rpmaio aio);
#define rpmaioUnlink(_aio)	\
    ((rpmaio)rpmioUnlinkPoolItem((rpmioItem)(_aio), __FUNCTION__, __FILE__, __LINE__))

/**
 * Reference a aio wrapper instance.
 * @param aio		aio wrapper
 * @return		new aio wrapper reference
 */
rpmaio rpmaioLink (rpmaio aio);
#define rpmaioLink(_aio)	\
    ((rpmaio)rpmioLinkPoolItem((rpmioItem)(_aio), __FUNCTION__, __FILE__, __LINE__))

/**
 * Destroy a aio wrapper.
 * @param aio		aio wrapper
 * @return		NULL on last dereference
 */
rpmaio rpmaioFree(rpmaio aio);
#define rpmaioFree(_aio)	\
    ((rpmaio)rpmioFreePoolItem((rpmioItem)(_aio), __FUNCTION__, __FILE__, __LINE__))

/**
 * Create an aio wrapper.
 * @return		aio wrapper
 */
rpmaio rpmaioNew(int fdno, int op, int prio, void *b, size_t nb,
		void * _sigev, off_t offset);

#ifdef __cplusplus
}
#endif

#endif	/* _H_RPMAIO_ */
