/** \ingroup rpmio
 * \file rpmio/rpmcvs.c
 */

#include "system.h"

#include <rpmiotypes.h>
#include <rpmio.h>	/* for *Pool methods */
#include <rpmlog.h>
#include <rpmurl.h>
#define	_RPMCVS_INTERNAL
#include <rpmcvs.h>

#include "debug.h"

static void rpmcvsFini(void * _cvs)
{
    rpmcvs cvs = (rpmcvs) _cvs;

    cvs->fn = _free(cvs->fn);
}

int _rpmcvs_debug = 0;

#define	rpmcvsDbug	NULL
#define	rpmcvsInit	NULL
RPMIOPOOL_MODULE(cvs)

rpmcvs rpmcvsNew(const char * fn, int flags)
{
    rpmcvs cvs = rpmcvsGetPool(_rpmcvsPool);

    if (fn)
	cvs->fn = xstrdup(fn);

    return rpmcvsLink(cvs);
}
