#ifndef	H_RPMCVS
#define	H_RPMCVS

/** \ingroup rpmio
 * \file rpmio/rpmcvs.h
 */

/** \ingroup rpmio
 */
extern int _rpmcvs_debug;

/** \ingroup rpmio
 */
typedef struct rpmcvs_s * rpmcvs;

#if defined(_RPMCVS_INTERNAL)

/** \ingroup rpmio
 */
struct rpmcvs_s {
    struct rpmioItem_s _item;	/*!< usage mutex and pool identifier. */
    const char * fn;
};
#endif	/* _RPMCVS_INTERNAL */

#ifdef __cplusplus
extern "C" {
#endif

/**
 * Unreference a cvs wrapper instance.
 * @param cvs		cvs wrapper
 * @return		NULL on last dereference
 */
rpmcvs rpmcvsUnlink (rpmcvs cvs);
#define	rpmcvsUnlink(_cvs)	\
    ((rpmcvs)rpmioUnlinkPoolItem((rpmioItem)(_cvs), __FUNCTION__, __FILE__, __LINE__))

/**
 * Reference a cvs wrapper instance.
 * @param cvs		cvs wrapper
 * @return		new cvs wrapper reference
 */
rpmcvs rpmcvsLink (rpmcvs cvs);
#define	rpmcvsLink(_cvs)	\
    ((rpmcvs)rpmioLinkPoolItem((rpmioItem)(_cvs), __FUNCTION__, __FILE__, __LINE__))

/**
 * Destroy a cvs wrapper.
 * @param cvs		cvs wrapper
 * @return		NULL on last dereference
 */
rpmcvs rpmcvsFree(rpmcvs cvs);
#define	rpmcvsFree(_cvs)	\
    ((rpmcvs)rpmioFreePoolItem((rpmioItem)(_cvs), __FUNCTION__, __FILE__, __LINE__))

/**
 * Create and load a cvs wrapper.
 * @param fn		cvs file
 * @param flags		cvs flags
 * @return		new cvs wrapper
 */
rpmcvs rpmcvsNew(const char * fn, int flags);

#ifdef __cplusplus
}
#endif

#endif	/* H_RPMCVS */
