#ifndef	_H_RPMEV_
#define	_H_RPMEV_

/**
 */
extern int _rpmev_debug;

typedef	struct rpmev_s * rpmev;

/**
 */
typedef enum rpmevType_e {
    RPMEV_TYPE_UNKNOWN	=  0,
    RPMEV_TYPE_IO	=  1,
    RPMEV_TYPE_TIMER	=  2,
    RPMEV_TYPE_PERIODIC	=  3,
    RPMEV_TYPE_SIGNAL	=  4,
    RPMEV_TYPE_CHILD	=  5,
    RPMEV_TYPE_STAT	=  6,
    RPMEV_TYPE_IDLE	=  7,

    RPMEV_TYPE_PREPARE	=  8,
    RPMEV_TYPE_CHECK	=  9,
    RPMEV_TYPE_FORK	= 10,
    RPMEV_TYPE_CLEANUP	= 11,
    RPMEV_TYPE_EMBED	= 12,
    RPMEV_TYPE_ASYNC	= 13,
} rpmevType;
#define	RPMEV_TYPE_MASK	0xf

/**
 */
#define _KFB(n) (1U << (n))
#define _MFB(n) (_KFB(n))
#define	RPMEV_FLAGS_TYPE_SHIFT	23
typedef enum rpmevFlags_e {
    RPMEV_FLAGS_NONE		= 0,
	/* bits 0-31 reserved */
} rpmevFlags;
#undef  _MFB
#undef  _KFB

#ifdef __cplusplus
extern "C" {
#endif

/**
 */
#if defined(_RPMEV_INTERNAL)

struct rpmev_s {
    struct rpmioItem_s _item;	/*!< usage mutex and pool identifier. */

    union ev_any_watcher evw;
#define	__evcb	evw.w.cb
    rpmevType evtype;
};

extern void rpmevDump(const char *msg, rpmev ev, FILE *fp);

extern unsigned rpmioEV;
extern struct poptOption rpmioEVTable[];
extern unsigned rpmioEVFLAG;
extern struct poptOption rpmioEVFLAGTable[];
extern unsigned rpmioEVBACKEND;
extern struct poptOption rpmioEVBACKENDTable[];

rpmev rpmevqGetHead(void);
void rpmevqPutTail(rpmev ev);
void rpmevqPutHead(rpmev ev);

#endif	/* _RPMEV_INTERNAL */

/**
 * Unreference a ev wrapper instance.
 * @param ev		ev wrapper
 * @return		NULL on last dereference
 */
rpmev rpmevUnlink (rpmev ev);
#define	rpmevUnlink(_ev)	\
    ((rpmev)rpmioUnlinkPoolItem((rpmioItem)(_ev), __FUNCTION__, __FILE__, __LINE__))

/**
 * Reference a ev wrapper instance.
 * @param ev		ev wrapper
 * @return		new ev wrapper reference
 */
rpmev rpmevLink (rpmev ev);
#define	rpmevLink(_ev)	\
    ((rpmev)rpmioLinkPoolItem((rpmioItem)(_ev), __FUNCTION__, __FILE__, __LINE__))

/**
 * Destroy a ev wrapper.
 * @param ev		ev wrapper
 * @return		NULL on last dereference
 */
rpmev rpmevFree(rpmev ev);
#define	rpmevFree(_ev)	\
    ((rpmev)rpmioFreePoolItem((rpmioItem)(_ev), __FUNCTION__, __FILE__, __LINE__))

/**
 * Create a ev wrapper.
 * @return		ev wrapper
 */
rpmev rpmevNew(rpmevType evtype, void * _evcb, ...);

#ifdef __cplusplus
}
#endif

#endif	/* _H_RPMEV_ */
