#ifndef	_H_RPMW_
#define	_H_RPMW_

/**
 */
extern int _rpmw_debug;

typedef	struct rpmw_s * rpmw;

#ifdef __cplusplus
extern "C" {
#endif

/**
 */
#if defined(_RPMW_INTERNAL)
#include <argv.h>

struct rpmw_s {
    struct rpmioItem_s _item;	/*!< usage mutex and pool identifier. */
    rpmmc mc;

#ifdef	DYING
    char * subtype;
    char * subname;
#endif

    unsigned nints;
    unsigned nptrs;
    unsigned noffs;
    unsigned nsizes;
    unsigned ndoubles;
    unsigned nlongs;
    unsigned nlonglongs;
    unsigned nother;
};

extern void rpmwDump(const char *msg, rpmw w, FILE *fp);

#endif	/* _RPMW_INTERNAL */

/**
 * Unreference a w wrapper instance.
 * @param w		w wrapper
 * @return		NULL on last dereference
 */
rpmw rpmwUnlink (rpmw w);
#define	rpmwUnlink(_w)	\
    ((rpmw)rpmioUnlinkPoolItem((rpmioItem)(_w), __FUNCTION__, __FILE__, __LINE__))

/**
 * Reference a w wrapper instance.
 * @param w		w wrapper
 * @return		new w wrapper reference
 */
rpmw rpmwLink (rpmw w);
#define	rpmwLink(_w)	\
    ((rpmw)rpmioLinkPoolItem((rpmioItem)(_w), __FUNCTION__, __FILE__, __LINE__))

/**
 * Destroy a w wrapper.
 * @param w		w wrapper
 * @return		NULL on last dereference
 */
rpmw rpmwFree(rpmw w);
#define	rpmwFree(_w)	\
    ((rpmw)rpmioFreePoolItem((rpmioItem)(_w), __FUNCTION__, __FILE__, __LINE__))

/**
 * Create a w wrapper.
 * @return		w wrapper
 */
rpmw rpmwNew(void);

#ifdef __cplusplus
}
#endif

#endif	/* _H_RPMW_ */
