
#include "microjson.c"

#include "system.h"
#include <stdarg.h>
#include <stdbool.h>
#include <stddef.h>
#include <getopt.h>
#include <math.h>
#include <termio.h>

#include <poptIO.h>
#include <rpmdefs.h>

#define	_RPMMQTT_INTERNAL
#include "rpmmqtt.h"

#include "debug.h"

/*==============================================================*/

static int _DoMQTT(rpmmqtt mqtt)
{
    rpmRC xx;
    int rc = 0;
static const char *const av[] = { "foo", "bar", "baz", NULL };
int ac = 3;
int qos = 2;

    xx = rpmmqttConnect(mqtt);

    xx = rpmmqttSubscribe(mqtt, av[0], qos);
    xx = rpmmqttUnsubscribe(mqtt, av[0]);
    xx = rpmmqttSubscribeMany(mqtt, ac, (char **)av);
    xx = rpmmqttUnsubscribeMany(mqtt, ac, (char **)av);

    xx = rpmmqttPub(mqtt, NULL, "bzzt ...", 0);
    xx = rpmmqttPub(mqtt, NULL, "bzzT ...", 0);
    xx = rpmmqttPub(mqtt, NULL, "bzZT ...", 0);
    xx = rpmmqttPub(mqtt, NULL, "bZZT ...", 0);
    xx = rpmmqttPub(mqtt, NULL, "BZZT ...", 0);
    xx = rpmmqttPub(mqtt, NULL, "SWAT !!!", 0);

    xx = rpmmqttDisconnect(mqtt);

    return rc;
}

int
main(int argc, char *argv[])
{
    rpmmqtt mqtt = NULL;
    int rc = -1;

    if (argc >= 2) {
	if (!strcmp(argv[1], "paho"))
	    argv[0] = "paho_pub";
	if (!strcmp(argv[1], "mosquitto"))
	    argv[0] = "mosquitto_pub";
	if (!strcmp(argv[1], "amqp"))
	    argv[0] = "amqp_pub";
	if (!strcmp(argv[1], "qpid"))
	    argv[0] = "qpid_pub";
	if (!strcmp(argv[1], "zmq"))
	    argv[0] = "zmq_pub";
    }

/* XXX global macros to initialize correctly. */
(void) rpmmqttDefineMacro(NULL, "_mqtt_persist 2", 0);
(void) rpmmqttDefineMacro(NULL, "_mqtt_cachedir /var/cache/mqtt", 0);

(void) rpmmqttDefineMacro(NULL, "nil %{!?nil}", 0);
(void) rpmmqttDefineMacro(NULL, "_mqtt_prefix %{now}", 0);

    mqtt = rpmmqttNew(argv, 0);
    rc = _DoMQTT(mqtt);
    if (mqtt->iob && rpmiobLen(mqtt->iob) > 0) {
	fprintf(stderr, "========== input msgs\n");
	fprintf(stderr, "%s", rpmiobStr(mqtt->iob));
    }
    mqtt = rpmmqttFree(mqtt);

    (void) rpmioClean();

    return rc;
}
